package RT::Principal;

use strict;
use RTx::Shredder::Exceptions;
use RTx::Shredder::Constants;
use RTx::Shredder::Dependencies;


sub Dependencies
{
	my $self = shift;
	my %args = (
			Shredder => undef,
			Flags => DEPENDS_ON,
			@_,
		   );

	unless( $self->id ) {
		RTx::Shredder::Exception->throw('Object is not loaded');
	}

	my $deps = RTx::Shredder::Dependencies->new();
	my $list = [];

# Group or User
# Could be wiped allready
	my $obj = $self->Object;
	if( defined $obj->id ) {
		push( @$list, $obj );
	}

# Access Control List
	my $objs = RT::ACL->new( $self->CurrentUser );
	$objs->Limit(
			FIELD => 'PrincipalId',
			OPERATOR        => '=',
			VALUE           => $self->Id
		   );
	push( @$list, $objs );

	$deps->_PushDependencies(
			BaseObj => $self,
			Flags => DEPENDS_ON,
			TargetObjs => $list,
			Shredder => $args{'Shredder'}
		);
	return $deps;
}

1;
